---

- name: "Install SSH Packages"
  ansible.builtin.apt:
    name: "openssh-client"
    state: "present"
    update_cache: true

- name: "Set up User Groups"
  ansible.builtin.group:
    name: "{{ item }}"
    state: "present"
  loop: "{{ identity_groups }}"

- name: Set up User Accounts
  ansible.builtin.user:
    append: true
    create_home: true
    generate_ssh_key: true
    group: "{{ item.group }}"
    groups: "{{ item.groups }}"
    name: "{{ item.name }}"
    password: "{{ item.password }}"
    remove: true
    shell: "{{ item.shell }}"
    ssh_key_comment: "{{ item.name }}@{{ ansible_hostname }}"
    ssh_key_file: .ssh/id_ed25519
    ssh_key_type: ed25519
    state: "{{ item.state }}"
    update_password: always
  loop: "{{ identity_users }}"

- name: 'SSH Rotate - Generate New'
  ansible.builtin.user:
    append: true
    create_home: true
    generate_ssh_key: true
    group: "{{ item.group }}"
    groups: "{{ item.groups }}"
    name: "{{ item.name }}"
    password: "{{ item.password }}"
    remove: true
    shell: "{{ item.shell }}"
    ssh_key_comment: "{{ item.name }}@{{ ansible_hostname }}"
    ssh_key_file: .ssh/id_ed25519
    ssh_key_type: ed25519
    state: "{{ item.state }}"
    update_password: always
  loop: "{{ identity_users }}"
  when: item.ssh_key_rotate|bool
  tags: ssh_key_rotation

- name: "Set up authorized_keys"
  ansible.posix.authorized_key:
    user: "{{ item.name }}"
    state: "present"
    key: "{{ item.ssh_authorized_keys }}"
  loop: "{{ identity_users }}"
